/*
 * Created by the DBAccessor generator.
 * Programmer: Lennart Martens
 * Date: 08/08/2012
 * Time: 21:02:40
 */
package com.compomics.proteocloud.db.accessor;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;

import com.compomics.util.db.interfaces.Deleteable;
import com.compomics.util.db.interfaces.Persistable;
import com.compomics.util.db.interfaces.Retrievable;
import com.compomics.util.db.interfaces.Updateable;

/*
 * CVS information:
 *
 * $Revision: 1.4 $
 * $Date: 2007/07/06 09:41:53 $
 */

/**
 * This class is a generated accessor for the Omssaproteinhit table.
 *
 * @author DBAccessor generator class (Lennart Martens).
 */
public class OmssaproteinhitTableAccessor implements Deleteable, Retrievable, Updateable, Persistable {

	/**
	 * This variable tracks changes to the object.
	 */
	protected boolean iUpdated = false;

	/**
	 * This variable can hold generated primary key columns.
	 */
	protected Object[] iKeys = null;

	/**
	 * This variable represents the contents for the 'omssaproteinhitid' column.
	 */
	protected long iOmssaproteinhitid = Long.MIN_VALUE;


	/**
	 * This variable represents the contents for the 'l_omssahitid' column.
	 */
	protected long iL_omssahitid = Long.MIN_VALUE;


	/**
	 * This variable represents the contents for the 'l_proteinid' column.
	 */
	protected long iL_proteinid = Long.MIN_VALUE;


	/**
	 * This variable represents the contents for the 'start' column.
	 */
	protected long iStart = Long.MIN_VALUE;


	/**
	 * This variable represents the contents for the 'end' column.
	 */
	protected long iEnd = Long.MIN_VALUE;


	/**
	 * This variable represents the key for the 'omssaproteinhitid' column.
	 */
	public static final String OMSSAPROTEINHITID = "OMSSAPROTEINHITID";

	/**
	 * This variable represents the key for the 'l_omssahitid' column.
	 */
	public static final String L_OMSSAHITID = "L_OMSSAHITID";

	/**
	 * This variable represents the key for the 'l_proteinid' column.
	 */
	public static final String L_PROTEINID = "L_PROTEINID";

	/**
	 * This variable represents the key for the 'start' column.
	 */
	public static final String START = "START";

	/**
	 * This variable represents the key for the 'end' column.
	 */
	public static final String END = "END";




	/**
	 * Default constructor.
	 */
	public OmssaproteinhitTableAccessor() {
	}

	/**
	 * This constructor allows the creation of the 'OmssaproteinhitTableAccessor' object based on a set of values in the HashMap.
	 *
	 * @param	aParams	HashMap with the parameters to initialize this object with.
	 *		<i>Please use only constants defined on this class as keys in the HashMap!</i>
	 */
	public OmssaproteinhitTableAccessor(HashMap aParams) {
		if(aParams.containsKey(OMSSAPROTEINHITID)) {
			this.iOmssaproteinhitid = ((Long)aParams.get(OMSSAPROTEINHITID)).longValue();
		}
		if(aParams.containsKey(L_OMSSAHITID)) {
			this.iL_omssahitid = ((Long)aParams.get(L_OMSSAHITID)).longValue();
		}
		if(aParams.containsKey(L_PROTEINID)) {
			this.iL_proteinid = ((Long)aParams.get(L_PROTEINID)).longValue();
		}
		if(aParams.containsKey(START)) {
			this.iStart = ((Long)aParams.get(START)).longValue();
		}
		if(aParams.containsKey(END)) {
			this.iEnd = ((Long)aParams.get(END)).longValue();
		}
		this.iUpdated = true;
	}


	/**
	 * This constructor allows the creation of the 'OmssaproteinhitTableAccessor' object based on a resultset
	 * obtained by a 'select * from Omssaproteinhit' query.
	 *
	 * @param	aResultSet	ResultSet with the required columns to initialize this object with.
	 * @exception	SQLException	when the ResultSet could not be read.
	 */
	public OmssaproteinhitTableAccessor(ResultSet aResultSet) throws SQLException {
		this.iOmssaproteinhitid = aResultSet.getLong("omssaproteinhitid");
		this.iL_omssahitid = aResultSet.getLong("l_omssahitid");
		this.iL_proteinid = aResultSet.getLong("l_proteinid");
		this.iStart = aResultSet.getLong("start");
		this.iEnd = aResultSet.getLong("end");

		this.iUpdated = true;
	}


	/**
	 * This method returns the value for the 'Omssaproteinhitid' column
	 * 
	 * @return	long	with the value for the Omssaproteinhitid column.
	 */
	public long getOmssaproteinhitid() {
		return this.iOmssaproteinhitid;
	}

	/**
	 * This method returns the value for the 'L_omssahitid' column
	 * 
	 * @return	long	with the value for the L_omssahitid column.
	 */
	public long getL_omssahitid() {
		return this.iL_omssahitid;
	}

	/**
	 * This method returns the value for the 'L_proteinid' column
	 * 
	 * @return	long	with the value for the L_proteinid column.
	 */
	public long getL_proteinid() {
		return this.iL_proteinid;
	}

	/**
	 * This method returns the value for the 'Start' column
	 * 
	 * @return	long	with the value for the Start column.
	 */
	public long getStart() {
		return this.iStart;
	}

	/**
	 * This method returns the value for the 'End' column
	 * 
	 * @return	long	with the value for the End column.
	 */
	public long getEnd() {
		return this.iEnd;
	}

	/**
	 * This method sets the value for the 'Omssaproteinhitid' column
	 * 
	 * @param	aOmssaproteinhitid	long with the value for the Omssaproteinhitid column.
	 */
	public void setOmssaproteinhitid(long aOmssaproteinhitid) {
		this.iOmssaproteinhitid = aOmssaproteinhitid;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'L_omssahitid' column
	 * 
	 * @param	aL_omssahitid	long with the value for the L_omssahitid column.
	 */
	public void setL_omssahitid(long aL_omssahitid) {
		this.iL_omssahitid = aL_omssahitid;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'L_proteinid' column
	 * 
	 * @param	aL_proteinid	long with the value for the L_proteinid column.
	 */
	public void setL_proteinid(long aL_proteinid) {
		this.iL_proteinid = aL_proteinid;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'Start' column
	 * 
	 * @param	aStart	long with the value for the Start column.
	 */
	public void setStart(long aStart) {
		this.iStart = aStart;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'End' column
	 * 
	 * @param	aEnd	long with the value for the End column.
	 */
	public void setEnd(long aEnd) {
		this.iEnd = aEnd;
		this.iUpdated = true;
	}



	/**
	 * This method allows the caller to delete the data represented by this
	 * object in a persistent store.
	 *
	 * @param   aConn Connection to the persitent store.
	 */
	public int delete(Connection aConn) throws SQLException {
		PreparedStatement lStat = aConn.prepareStatement("DELETE FROM omssaproteinhit WHERE omssaproteinhitid = ?");
		lStat.setLong(1, iOmssaproteinhitid);
		int result = lStat.executeUpdate();
		lStat.close();
		return result;
	}


	/**
	 * This method allows the caller to read data for this
	 * object from a persistent store based on the specified keys.
	 *
	 * @param   aConn Connection to the persitent store.
	 */
	public void retrieve(Connection aConn, HashMap aKeys) throws SQLException {
		// First check to see whether all PK fields are present.
		if(!aKeys.containsKey(OMSSAPROTEINHITID)) {
			throw new IllegalArgumentException("Primary key field 'OMSSAPROTEINHITID' is missing in HashMap!");
		} else {
			iOmssaproteinhitid = ((Long)aKeys.get(OMSSAPROTEINHITID)).longValue();
		}
		// In getting here, we probably have all we need to continue. So let's...
		PreparedStatement lStat = aConn.prepareStatement("SELECT * FROM omssaproteinhit WHERE omssaproteinhitid = ?");
		lStat.setLong(1, iOmssaproteinhitid);
		ResultSet lRS = lStat.executeQuery();
		int hits = 0;
		while(lRS.next()) {
			hits++;
			iOmssaproteinhitid = lRS.getLong("omssaproteinhitid");
			iL_omssahitid = lRS.getLong("l_omssahitid");
			iL_proteinid = lRS.getLong("l_proteinid");
			iStart = lRS.getLong("start");
			iEnd = lRS.getLong("end");
		}
		lRS.close();
		lStat.close();
		if(hits>1) {
			throw new SQLException("More than one hit found for the specified primary keys in the 'omssaproteinhit' table! Object is initialized to last row returned.");
		} else if(hits == 0) {
			throw new SQLException("No hits found for the specified primary keys in the 'omssaproteinhit' table! Object is not initialized correctly!");
		}
	}
	/**
	 * This method allows the caller to obtain a basic select for this table.
	 *
	 * @return   String with the basic select statement for this table.
	 */
	public static String getBasicSelect(){
		return "select * from omssaproteinhit";
	}

	/**
	 * This method allows the caller to obtain all rows for this
	 * table from a persistent store.
	 *
	 * @param   aConn Connection to the persitent store.
	 * @return   ArrayList<OmssaproteinhitTableAccessor>   with all entries for this table.
	 */
	public static ArrayList<OmssaproteinhitTableAccessor> retrieveAllEntries(Connection aConn) throws SQLException {
		ArrayList<OmssaproteinhitTableAccessor>  entities = new ArrayList<OmssaproteinhitTableAccessor>();
		Statement stat = aConn.createStatement();
		ResultSet rs = stat.executeQuery(getBasicSelect());
		while(rs.next()) {
			entities.add(new OmssaproteinhitTableAccessor(rs));
		}
		rs.close();
		stat.close();
		return entities;
	}



	/**
	 * This method allows the caller to update the data represented by this
	 * object in a persistent store.
	 *
	 * @param   aConn Connection to the persitent store.
	 */
	public int update(Connection aConn) throws SQLException {
		if(!this.iUpdated) {
			return 0;
		}
		PreparedStatement lStat = aConn.prepareStatement("UPDATE omssaproteinhit SET omssaproteinhitid = ?, l_omssahitid = ?, l_proteinid = ?, start = ?, end = ? WHERE omssaproteinhitid = ?");
		lStat.setLong(1, iOmssaproteinhitid);
		lStat.setLong(2, iL_omssahitid);
		lStat.setLong(3, iL_proteinid);
		lStat.setLong(4, iStart);
		lStat.setLong(5, iEnd);
		lStat.setLong(6, iOmssaproteinhitid);
		int result = lStat.executeUpdate();
		lStat.close();
		this.iUpdated = false;
		return result;
	}


	/**
	 * This method allows the caller to insert the data represented by this
	 * object in a persistent store.
	 *
	 * @param   aConn Connection to the persitent store.
	 */
	public int persist(Connection aConn) throws SQLException {
		PreparedStatement lStat = aConn.prepareStatement("INSERT INTO omssaproteinhit (omssaproteinhitid, l_omssahitid, l_proteinid, start, end) values(?, ?, ?, ?, ?)");
		if(iOmssaproteinhitid == Long.MIN_VALUE) {
			lStat.setNull(1, 4);
		} else {
			lStat.setLong(1, iOmssaproteinhitid);
		}
		if(iL_omssahitid == Long.MIN_VALUE) {
			lStat.setNull(2, 4);
		} else {
			lStat.setLong(2, iL_omssahitid);
		}
		if(iL_proteinid == Long.MIN_VALUE) {
			lStat.setNull(3, 4);
		} else {
			lStat.setLong(3, iL_proteinid);
		}
		if(iStart == Long.MIN_VALUE) {
			lStat.setNull(4, 4);
		} else {
			lStat.setLong(4, iStart);
		}
		if(iEnd == Long.MIN_VALUE) {
			lStat.setNull(5, 4);
		} else {
			lStat.setLong(5, iEnd);
		}
		int result = lStat.executeUpdate();

		// Retrieving the generated keys (if any).
		ResultSet lrsKeys = lStat.getGeneratedKeys();
		ResultSetMetaData lrsmKeys = lrsKeys.getMetaData();
		int colCount = lrsmKeys.getColumnCount();
		iKeys = new Object[colCount];
		while(lrsKeys.next()) {
			for(int i=0;i<iKeys.length;i++) {
				iKeys[i] = lrsKeys.getObject(i+1);
			}
		}
		lrsKeys.close();
		lStat.close();
		// Verify that we have a single, generated key.
		if(iKeys != null && iKeys.length == 1 && iKeys[0] != null) {
			// Since we have exactly one key specified, and only
			// one Primary Key column, we can infer that this was the
			// generated column, and we can therefore initialize it here.
			iOmssaproteinhitid = ((Number) iKeys[0]).longValue();
		}
		this.iUpdated = false;
		return result;
	}

	/**
	 * This method will return the automatically generated key for the insert if 
	 * one was triggered, or 'null' otherwise.
	 *
	 * @return	Object[]	with the generated keys.
	 */
	public Object[] getGeneratedKeys() {
		return this.iKeys;
	}

}