package com.compomics.proteocloud.util;

/**
 * Class for the Credentials.
 * @author Thilo Muth
 *
 */
public class Credentials {
	
	/**
	 * The keypair.
	 */
	private String keypair;
	
	/**
	 * The security group.
	 */
	private String group;
	
	/**
	 * The access key.
	 */
	private String accesskey;
	
	/**
	 * The secret access key.
	 */
	private String secretaccesskey;
	
	/**
	 * The constructor for the Credentials using fields.
	 * @param keypair
	 * @param group
	 * @param accesskey
	 * @param secretaccesskey
	 */
	public Credentials(String keypair, String group, String accesskey, String secretaccesskey) {
		super();
		this.keypair = keypair;
		this.group = group;
		this.accesskey = accesskey;
		this.secretaccesskey = secretaccesskey;
	}

	public String getKeypair() {
		return keypair;
	}

	public String getGroup() {
		return group;
	}

	public String getAccesskey() {
		return accesskey;
	}

	public String getSecretaccesskey() {
		return secretaccesskey;
	}
	
	
}
