/*
 * Created by the DBAccessor generator.
 * Programmer: Lennart Martens
 * Date: 08/08/2012
 * Time: 21:02:23
 */
package com.compomics.proteocloud.db.accessor;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;

import com.compomics.util.db.interfaces.Deleteable;
import com.compomics.util.db.interfaces.Persistable;
import com.compomics.util.db.interfaces.Retrievable;
import com.compomics.util.db.interfaces.Updateable;

/*
 * CVS information:
 *
 * $Revision: 1.4 $
 * $Date: 2007/07/06 09:41:53 $
 */

/**
 * This class is a generated accessor for the Spectrum table.
 *
 * @author DBAccessor generator class (Lennart Martens).
 */
public class SpectrumTableAccessor implements Deleteable, Retrievable, Updateable, Persistable {

	/**
	 * This variable tracks changes to the object.
	 */
	protected boolean iUpdated = false;

	/**
	 * This variable can hold generated primary key columns.
	 */
	protected Object[] iKeys = null;

	/**
	 * This variable represents the contents for the 'spectrumid' column.
	 */
	protected long iSpectrumid = Long.MIN_VALUE;


	/**
	 * This variable represents the contents for the 'l_projectid' column.
	 */
	protected long iL_projectid = Long.MIN_VALUE;


	/**
	 * This variable represents the contents for the 'filename' column.
	 */
	protected String iFilename = null;


	/**
	 * This variable represents the contents for the 'spectrumname' column.
	 */
	protected String iSpectrumname = null;


	/**
	 * This variable represents the contents for the 'total_spectrum_intensity' column.
	 */
	protected Number iTotal_spectrum_intensity = null;


	/**
	 * This variable represents the contents for the 'highest_peak_in_spectrum' column.
	 */
	protected Number iHighest_peak_in_spectrum = null;


	/**
	 * This variable represents the contents for the 'creationdate' column.
	 */
	protected java.sql.Timestamp iCreationdate = null;


	/**
	 * This variable represents the contents for the 'modificationdate' column.
	 */
	protected java.sql.Timestamp iModificationdate = null;


	/**
	 * This variable represents the key for the 'spectrumid' column.
	 */
	public static final String SPECTRUMID = "SPECTRUMID";

	/**
	 * This variable represents the key for the 'l_projectid' column.
	 */
	public static final String L_PROJECTID = "L_PROJECTID";

	/**
	 * This variable represents the key for the 'filename' column.
	 */
	public static final String FILENAME = "FILENAME";

	/**
	 * This variable represents the key for the 'spectrumname' column.
	 */
	public static final String SPECTRUMNAME = "SPECTRUMNAME";

	/**
	 * This variable represents the key for the 'total_spectrum_intensity' column.
	 */
	public static final String TOTAL_SPECTRUM_INTENSITY = "TOTAL_SPECTRUM_INTENSITY";

	/**
	 * This variable represents the key for the 'highest_peak_in_spectrum' column.
	 */
	public static final String HIGHEST_PEAK_IN_SPECTRUM = "HIGHEST_PEAK_IN_SPECTRUM";

	/**
	 * This variable represents the key for the 'creationdate' column.
	 */
	public static final String CREATIONDATE = "CREATIONDATE";

	/**
	 * This variable represents the key for the 'modificationdate' column.
	 */
	public static final String MODIFICATIONDATE = "MODIFICATIONDATE";




	/**
	 * Default constructor.
	 */
	public SpectrumTableAccessor() {
	}

	/**
	 * This constructor allows the creation of the 'SpectrumTableAccessor' object based on a set of values in the HashMap.
	 *
	 * @param	aParams	HashMap with the parameters to initialize this object with.
	 *		<i>Please use only constants defined on this class as keys in the HashMap!</i>
	 */
	public SpectrumTableAccessor(HashMap aParams) {
		if(aParams.containsKey(SPECTRUMID)) {
			this.iSpectrumid = ((Long)aParams.get(SPECTRUMID)).longValue();
		}
		if(aParams.containsKey(L_PROJECTID)) {
			this.iL_projectid = ((Long)aParams.get(L_PROJECTID)).longValue();
		}
		if(aParams.containsKey(FILENAME)) {
			this.iFilename = (String)aParams.get(FILENAME);
		}
		if(aParams.containsKey(SPECTRUMNAME)) {
			this.iSpectrumname = (String)aParams.get(SPECTRUMNAME);
		}
		if(aParams.containsKey(TOTAL_SPECTRUM_INTENSITY)) {
			this.iTotal_spectrum_intensity = (Number)aParams.get(TOTAL_SPECTRUM_INTENSITY);
		}
		if(aParams.containsKey(HIGHEST_PEAK_IN_SPECTRUM)) {
			this.iHighest_peak_in_spectrum = (Number)aParams.get(HIGHEST_PEAK_IN_SPECTRUM);
		}
		if(aParams.containsKey(CREATIONDATE)) {
			this.iCreationdate = (java.sql.Timestamp)aParams.get(CREATIONDATE);
		}
		if(aParams.containsKey(MODIFICATIONDATE)) {
			this.iModificationdate = (java.sql.Timestamp)aParams.get(MODIFICATIONDATE);
		}
		this.iUpdated = true;
	}


	/**
	 * This constructor allows the creation of the 'SpectrumTableAccessor' object based on a resultset
	 * obtained by a 'select * from Spectrum' query.
	 *
	 * @param	aResultSet	ResultSet with the required columns to initialize this object with.
	 * @exception	SQLException	when the ResultSet could not be read.
	 */
	public SpectrumTableAccessor(ResultSet aResultSet) throws SQLException {
		this.iSpectrumid = aResultSet.getLong("spectrumid");
		this.iL_projectid = aResultSet.getLong("l_projectid");
		this.iFilename = (String)aResultSet.getObject("filename");
		this.iSpectrumname = (String)aResultSet.getObject("spectrumname");
		this.iTotal_spectrum_intensity = (Number)aResultSet.getObject("total_spectrum_intensity");
		this.iHighest_peak_in_spectrum = (Number)aResultSet.getObject("highest_peak_in_spectrum");
		this.iCreationdate = (java.sql.Timestamp)aResultSet.getObject("creationdate");
		this.iModificationdate = (java.sql.Timestamp)aResultSet.getObject("modificationdate");

		this.iUpdated = true;
	}


	/**
	 * This method returns the value for the 'Spectrumid' column
	 * 
	 * @return	long	with the value for the Spectrumid column.
	 */
	public long getSpectrumid() {
		return this.iSpectrumid;
	}

	/**
	 * This method returns the value for the 'L_projectid' column
	 * 
	 * @return	long	with the value for the L_projectid column.
	 */
	public long getL_projectid() {
		return this.iL_projectid;
	}

	/**
	 * This method returns the value for the 'Filename' column
	 * 
	 * @return	String	with the value for the Filename column.
	 */
	public String getFilename() {
		return this.iFilename;
	}

	/**
	 * This method returns the value for the 'Spectrumname' column
	 * 
	 * @return	String	with the value for the Spectrumname column.
	 */
	public String getSpectrumname() {
		return this.iSpectrumname;
	}

	/**
	 * This method returns the value for the 'Total_spectrum_intensity' column
	 * 
	 * @return	Number	with the value for the Total_spectrum_intensity column.
	 */
	public Number getTotal_spectrum_intensity() {
		return this.iTotal_spectrum_intensity;
	}

	/**
	 * This method returns the value for the 'Highest_peak_in_spectrum' column
	 * 
	 * @return	Number	with the value for the Highest_peak_in_spectrum column.
	 */
	public Number getHighest_peak_in_spectrum() {
		return this.iHighest_peak_in_spectrum;
	}

	/**
	 * This method returns the value for the 'Creationdate' column
	 * 
	 * @return	java.sql.Timestamp	with the value for the Creationdate column.
	 */
	public java.sql.Timestamp getCreationdate() {
		return this.iCreationdate;
	}

	/**
	 * This method returns the value for the 'Modificationdate' column
	 * 
	 * @return	java.sql.Timestamp	with the value for the Modificationdate column.
	 */
	public java.sql.Timestamp getModificationdate() {
		return this.iModificationdate;
	}

	/**
	 * This method sets the value for the 'Spectrumid' column
	 * 
	 * @param	aSpectrumid	long with the value for the Spectrumid column.
	 */
	public void setSpectrumid(long aSpectrumid) {
		this.iSpectrumid = aSpectrumid;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'L_projectid' column
	 * 
	 * @param	aL_projectid	long with the value for the L_projectid column.
	 */
	public void setL_projectid(long aL_projectid) {
		this.iL_projectid = aL_projectid;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'Filename' column
	 * 
	 * @param	aFilename	String with the value for the Filename column.
	 */
	public void setFilename(String aFilename) {
		this.iFilename = aFilename;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'Spectrumname' column
	 * 
	 * @param	aSpectrumname	String with the value for the Spectrumname column.
	 */
	public void setSpectrumname(String aSpectrumname) {
		this.iSpectrumname = aSpectrumname;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'Total_spectrum_intensity' column
	 * 
	 * @param	aTotal_spectrum_intensity	Number with the value for the Total_spectrum_intensity column.
	 */
	public void setTotal_spectrum_intensity(Number aTotal_spectrum_intensity) {
		this.iTotal_spectrum_intensity = aTotal_spectrum_intensity;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'Highest_peak_in_spectrum' column
	 * 
	 * @param	aHighest_peak_in_spectrum	Number with the value for the Highest_peak_in_spectrum column.
	 */
	public void setHighest_peak_in_spectrum(Number aHighest_peak_in_spectrum) {
		this.iHighest_peak_in_spectrum = aHighest_peak_in_spectrum;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'Creationdate' column
	 * 
	 * @param	aCreationdate	java.sql.Timestamp with the value for the Creationdate column.
	 */
	public void setCreationdate(java.sql.Timestamp aCreationdate) {
		this.iCreationdate = aCreationdate;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'Modificationdate' column
	 * 
	 * @param	aModificationdate	java.sql.Timestamp with the value for the Modificationdate column.
	 */
	public void setModificationdate(java.sql.Timestamp aModificationdate) {
		this.iModificationdate = aModificationdate;
		this.iUpdated = true;
	}



	/**
	 * This method allows the caller to delete the data represented by this
	 * object in a persistent store.
	 *
	 * @param   aConn Connection to the persitent store.
	 */
	public int delete(Connection aConn) throws SQLException {
		PreparedStatement lStat = aConn.prepareStatement("DELETE FROM spectrum WHERE spectrumid = ?");
		lStat.setLong(1, iSpectrumid);
		int result = lStat.executeUpdate();
		lStat.close();
		return result;
	}


	/**
	 * This method allows the caller to read data for this
	 * object from a persistent store based on the specified keys.
	 *
	 * @param   aConn Connection to the persitent store.
	 */
	public void retrieve(Connection aConn, HashMap aKeys) throws SQLException {
		// First check to see whether all PK fields are present.
		if(!aKeys.containsKey(SPECTRUMID)) {
			throw new IllegalArgumentException("Primary key field 'SPECTRUMID' is missing in HashMap!");
		} else {
			iSpectrumid = ((Long)aKeys.get(SPECTRUMID)).longValue();
		}
		// In getting here, we probably have all we need to continue. So let's...
		PreparedStatement lStat = aConn.prepareStatement("SELECT * FROM spectrum WHERE spectrumid = ?");
		lStat.setLong(1, iSpectrumid);
		ResultSet lRS = lStat.executeQuery();
		int hits = 0;
		while(lRS.next()) {
			hits++;
			iSpectrumid = lRS.getLong("spectrumid");
			iL_projectid = lRS.getLong("l_projectid");
			iFilename = (String)lRS.getObject("filename");
			iSpectrumname = (String)lRS.getObject("spectrumname");
			iTotal_spectrum_intensity = (Number)lRS.getObject("total_spectrum_intensity");
			iHighest_peak_in_spectrum = (Number)lRS.getObject("highest_peak_in_spectrum");
			iCreationdate = (java.sql.Timestamp)lRS.getObject("creationdate");
			iModificationdate = (java.sql.Timestamp)lRS.getObject("modificationdate");
		}
		lRS.close();
		lStat.close();
		if(hits>1) {
			throw new SQLException("More than one hit found for the specified primary keys in the 'spectrum' table! Object is initialized to last row returned.");
		} else if(hits == 0) {
			throw new SQLException("No hits found for the specified primary keys in the 'spectrum' table! Object is not initialized correctly!");
		}
	}
	/**
	 * This method allows the caller to obtain a basic select for this table.
	 *
	 * @return   String with the basic select statement for this table.
	 */
	public static String getBasicSelect(){
		return "select * from spectrum";
	}

	/**
	 * This method allows the caller to obtain all rows for this
	 * table from a persistent store.
	 *
	 * @param   aConn Connection to the persitent store.
	 * @return   ArrayList<SpectrumTableAccessor>   with all entries for this table.
	 */
	public static ArrayList<SpectrumTableAccessor> retrieveAllEntries(Connection aConn) throws SQLException {
		ArrayList<SpectrumTableAccessor>  entities = new ArrayList<SpectrumTableAccessor>();
		Statement stat = aConn.createStatement();
		ResultSet rs = stat.executeQuery(getBasicSelect());
		while(rs.next()) {
			entities.add(new SpectrumTableAccessor(rs));
		}
		rs.close();
		stat.close();
		return entities;
	}



	/**
	 * This method allows the caller to update the data represented by this
	 * object in a persistent store.
	 *
	 * @param   aConn Connection to the persitent store.
	 */
	public int update(Connection aConn) throws SQLException {
		if(!this.iUpdated) {
			return 0;
		}
		PreparedStatement lStat = aConn.prepareStatement("UPDATE spectrum SET spectrumid = ?, l_projectid = ?, filename = ?, spectrumname = ?, total_spectrum_intensity = ?, highest_peak_in_spectrum = ?, creationdate = ?, modificationdate = CURRENT_TIMESTAMP WHERE spectrumid = ?");
		lStat.setLong(1, iSpectrumid);
		lStat.setLong(2, iL_projectid);
		lStat.setObject(3, iFilename);
		lStat.setObject(4, iSpectrumname);
		lStat.setObject(5, iTotal_spectrum_intensity);
		lStat.setObject(6, iHighest_peak_in_spectrum);
		lStat.setObject(7, iCreationdate);
		lStat.setLong(8, iSpectrumid);
		int result = lStat.executeUpdate();
		lStat.close();
		this.iUpdated = false;
		return result;
	}


	/**
	 * This method allows the caller to insert the data represented by this
	 * object in a persistent store.
	 *
	 * @param   aConn Connection to the persitent store.
	 */
	public int persist(Connection aConn) throws SQLException {
		PreparedStatement lStat = aConn.prepareStatement("INSERT INTO spectrum (spectrumid, l_projectid, filename, spectrumname, total_spectrum_intensity, highest_peak_in_spectrum, creationdate, modificationdate) values(?, ?, ?, ?, ?, ?, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP)");
		if(iSpectrumid == Long.MIN_VALUE) {
			lStat.setNull(1, 4);
		} else {
			lStat.setLong(1, iSpectrumid);
		}
		if(iL_projectid == Long.MIN_VALUE) {
			lStat.setNull(2, 4);
		} else {
			lStat.setLong(2, iL_projectid);
		}
		if(iFilename == null) {
			lStat.setNull(3, 12);
		} else {
			lStat.setObject(3, iFilename);
		}
		if(iSpectrumname == null) {
			lStat.setNull(4, 12);
		} else {
			lStat.setObject(4, iSpectrumname);
		}
		if(iTotal_spectrum_intensity == null) {
			lStat.setNull(5, 3);
		} else {
			lStat.setObject(5, iTotal_spectrum_intensity);
		}
		if(iHighest_peak_in_spectrum == null) {
			lStat.setNull(6, 3);
		} else {
			lStat.setObject(6, iHighest_peak_in_spectrum);
		}
		int result = lStat.executeUpdate();

		// Retrieving the generated keys (if any).
		ResultSet lrsKeys = lStat.getGeneratedKeys();
		ResultSetMetaData lrsmKeys = lrsKeys.getMetaData();
		int colCount = lrsmKeys.getColumnCount();
		iKeys = new Object[colCount];
		while(lrsKeys.next()) {
			for(int i=0;i<iKeys.length;i++) {
				iKeys[i] = lrsKeys.getObject(i+1);
			}
		}
		lrsKeys.close();
		lStat.close();
		// Verify that we have a single, generated key.
		if(iKeys != null && iKeys.length == 1 && iKeys[0] != null) {
			// Since we have exactly one key specified, and only
			// one Primary Key column, we can infer that this was the
			// generated column, and we can therefore initialize it here.
			iSpectrumid = ((Number) iKeys[0]).longValue();
		}
		this.iUpdated = false;
		return result;
	}

	/**
	 * This method will return the automatically generated key for the insert if 
	 * one was triggered, or 'null' otherwise.
	 *
	 * @return	Object[]	with the generated keys.
	 */
	public Object[] getGeneratedKeys() {
		return this.iKeys;
	}

}