package com.compomics.proteocloud.jobs;

/**
 * This container class represents a cloud job.
 * It's used for the table updating functionality in the UI. 
 * @author Thilo Muth
 *
 */
public class CloudJob {
	
	private String instanceID;
	private String currentJob;
	private String state;
	private String error;
    private String currentFile;
	
	public String getInstanceID() {
		return instanceID;
	}
	public void setInstanceID(String instanceID) {
		this.instanceID = instanceID;
	}
	public String getCurrentJob() {
		return currentJob;
	}
	public void setCurrentJob(String currentJob) {
		this.currentJob = currentJob;
	}
	
	public String getState() {
		return state;
	}
	public void setState(String state) {
		this.state = state;
	}
	public String getError() {
		return error;
	}
	public void setError(String error) {
		this.error = error;
	}
    public String getCurrentFile() {
		return currentFile;
	}
	public void setCurrentFile(String currentFile) {
		this.currentFile = currentFile;
	}
}
